CC=cc/name=(as_is,short)\
	/include=([],[-.include],[-.appframe],[-.apputil],[-.bitmap],[-.ind])

OBS	=	\
		utilMemoryBuffer.obj,\
		utilEndian.obj,\
		sioStdio.obj,\
		sioSmtp.obj,\
		sioPfb.obj,\
		sioMemory.obj,\
		sioLzw.obj,\
		sioHttp.obj,\
		sioHex.obj,\
		sioGeneral.obj,\
		sioEndian.obj,\
		sioBlocked.obj,\
		sioBase64.obj,\
		psGlyphs.obj,\
		psFont.obj,\
		docFont.obj,\
		appUrl.obj,\
		appUnit.obj,\
		appTagval.obj,\
		appSystem.obj,\
		appPs.obj,\
		utilPrinter.obj,\
		appPaper.obj,\
		appGeoString.obj,\
		appGeo.obj,\
		appDebug.obj,\
		appCgiIn.obj,\
		utilPropMask.obj,\
		utilPrinter.obj,\
		sioMsLz77.obj,\
		sioFlate.obj

all : config.h [-.lib]apputil.olb
    write sys$output "all done in [.apputil]"

config.h : config.h_vms
	 copy config.h_vms config.h

[-.lib]apputil.olb :	$(OBS)
	library/create apputil.olb $(OBS)
	rename apputil.olb [-.lib]

appCgiIn.obj : \
    appCgiIn.c \
    config.h \
    [-.appUtil]appCgiIn.h \
    [-.appUtil]appTagval.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

appDebug.obj : \
    appDebug.c \
    config.h \
    [-.include]appDebug.h

appGeo.obj : \
    appGeo.c \
    config.h \
    appGeo.h \
    [-.appUtil]utilPropMask.h \
    utilPropMask.h

appGeoString.obj : \
    appGeoString.c \
    config.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h \
    appUnit.h \
    appGeoString.h

appPaper.obj : \
    appPaper.c \
    config.h \
    appPaper.h \
    appGeoString.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

appPs.obj : \
    appPs.c \
    config.h \
    [-.appUtil]appPs.h \
    [-.appUtil]appGeo.h \
    [-.appUtil]utilPropMask.h \
    [-.appUtil]docFont.h \
    [-.appUtil]psFont.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

appSystem.obj : \
    appSystem.c \
    config.h \
    [-.appUtil]appSystem.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

appTagval.obj : \
    appTagval.c \
    config.h \
    [-.appUtil]appTagval.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

appUnit.obj : \
    appUnit.c \
    config.h \
    appUnit.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

appUrl.obj : \
    appUrl.c \
    config.h \
    [-.appUtil]appUrl.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

docFont.obj : \
    docFont.c \
    config.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h \
    utilPropMask.h \
    docFont.h \
    [-.appUtil]utilPropMask.h

psFont.obj : \
    psFont.c \
    config.h \
    docFont.h \
    [-.appUtil]utilPropMask.h \
    psFont.h \
    [-.appUtil]docFont.h \
    appSystem.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

psGlyphs.obj : \
    psGlyphs.c \
    config.h \
    psFont.h \
    [-.appUtil]docFont.h \
    [-.appUtil]utilPropMask.h \
    [-.include]charnames.h

sioBase64.obj : \
    sioBase64.c \
    config.h \
    sioBase64.h \
    [-.appUtil]sioGeneral.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioBlocked.obj : \
    sioBlocked.c \
    config.h \
    sioBlocked.h \
    [-.appUtil]sioGeneral.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioEndian.obj : \
    sioEndian.c \
    config.h \
    [-.appUtil]sioEndian.h \
    [-.appUtil]utilEndian.h \
    [-.appUtil]sioGeneral.h

sioFlate.obj : \
    sioFlate.c \
    config.h \
    sioFlate.h \
    [-.appUtil]sioGeneral.h \
    sioEndian.h \
    [-.appUtil]utilEndian.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioGeneral.obj : \
    sioGeneral.c \
    config.h \
    sioGeneral.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioHex.obj : \
    sioHex.c \
    config.h \
    sioHex.h \
    [-.appUtil]sioGeneral.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioHttp.obj : \
    sioHttp.c \
    config.h \
    [-.appUtil]sioHttp.h \
    [-.appUtil]sioGeneral.h \
    [-.appUtil]appSystem.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioLzw.obj : \
    sioLzw.c \
    config.h \
    sioLzw.h \
    [-.appUtil]sioGeneral.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioMemory.obj : \
    sioMemory.c \
    config.h \
    [-.appUtil]sioMemory.h \
    [-.appUtil]sioGeneral.h \
    [-.appUtil]utilMemoryBuffer.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioMsLz77.obj : \
    sioMsLz77.c \
    config.h \
    sioMsLz77.h \
    [-.appUtil]sioGeneral.h \
    sioEndian.h \
    [-.appUtil]utilEndian.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioPfb.obj : \
    sioPfb.c \
    config.h \
    sioPfb.h \
    [-.appUtil]sioGeneral.h \
    [-.appUtil]sioEndian.h \
    [-.appUtil]utilEndian.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioSmtp.obj : \
    sioSmtp.c \
    config.h \
    [-.appUtil]sioSmtp.h \
    [-.appUtil]appSystem.h \
    [-.appUtil]sioGeneral.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

sioStdio.obj : \
    sioStdio.c \
    config.h \
    [-.appUtil]sioStdio.h \
    [-.appUtil]sioGeneral.h \
    [-.include]appDebugoff.h \
    [-.include]appDebug.h

utilEndian.obj : \
    utilEndian.c \
    config.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h \
    utilEndian.h

utilMemoryBuffer.obj : \
    utilMemoryBuffer.c \
    config.h \
    [-.appUtil]utilMemoryBuffer.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

utilPrinter.obj : \
    utilPrinter.c \
    config.h \
    utilPrinter.h \
    [-.include]appDebugon.h \
    [-.include]appDebug.h

utilPropMask.obj : \
    utilPropMask.c \
    [-.appUtil]utilPropMask.h

